/////////////////////////////////////////////////////////////////////////////////
//
// SignatureListener.cpp
//
// Copyright (C) 2000 YUGA. All rights reserved.
//
/*
 * $Log: SignatureListener.cpp,v $
 * Revision 1.6  2001/01/20 07:40:17  syou
 * - Í̍ہAToACcABcc̃AhXDefault RecipientƂĈ悤ɂA
 *   ܂Cӂ̌JgĈÍł悤ɂB܂ADefault Recipient
 *   Default Private Key̒ǉ\ɂIvV݂BA
 *   ͂Ȃr(^^;
 *
 * Revision 1.5  2000/11/29 12:46:35  syou
 * - broken version line ̏CBsɂ܂Ă͖̂炩Ƀ~X
 *   łB
 *
 * Revision 1.4  2000/11/23 07:17:58  syou
 * - DllMainŎqXbh쐬Ă߁APGPB2[hĂȂԂŁA
 *   B2̃vOC̑I_CAOJƂAB2ƂɗĂ
 *   oOCBWindows98ŏ؂̃bZ[WpƂȂĂ̂C
 *   BlXg`ɂȂĂPGP/MIME[̕ƌ؂肭oȂ
 *   oOPgpb2::decodePgpMailPartPgpb2::decodePgpMailPart2ŏCB
 *   Decode܂̃WbŇccłB
 *   PGP/MIMEbZ[W̕ƌ؋@\ǉB،ʂɂẮAƂ肠
 *   PGPlogɕ\悤ɂ݂܂Bo̓bZ[W\[X֒ǕB
 *
 * Revision 1.3  2000/11/07 15:57:20  syou
 * - PGPsdkpX[h͎ɍsĂZLeBtbNɂ镛pŁA
 *   MFCpWindow쐬Becky!AT[g邱Ƃh߂ɁAPGPB2
 *   }`XbhBāAversion 0.00.1̌ĂƂ
 *   ܂B
 *   [STLx[X̓ƎNXɕύXBsx̑̌ړI
 *   ƂāAVC++tSTLł͂ȂASTLport-4.0̗pB
 *   CO[Ů҂ɉ邽߁Aeo̓bZ[W\[Xɓ{ŏ
 *   ł̂AXɃ\[Xֈڂ͂߂Ă܂B
 *   PGP/MIMEbZ[W̌؂ƕɑΉ悤Ǝ݂iڂ͓
 *   vO\[XQƁjA،ʂ̕\@ɗǂ@v΂ȂB
 *   ACfAR[h΂肢܂B
 *
 * Revision 1.2  2000/07/15 02:09:56  syou
 * - PGP/MIMEÍƏꂽ[̏؂Bclass
 *   CDecryptListenerclass CSignatureListenerhAPGP/MIME
 *   ꂽ[̏؂ƁA\[`LBƂ
 *   CɂȂ̂͂2̃NX̖OAPGPEventtׂH
 *
 * Revision 1.1  2000/07/13 15:12:24  syou
 * - PGP/MIME`̈Í[̕B
 *   PGPEventHandlerAeListenerƂɎ悤ɂBclass CEventListener
 *   hIuWFNgEventHandlerꂼĎgB
 *   SignatureData.h폜AEventListener.hAEventListener.cppASignatureListener.h
 *   SignatureListener.cppADecryptListener.hADecryptListener.cppǉB
 *   count_ptr<CBkMailPart*>CBkMailPartPtrtypedefB
 *   \[XSʂɓnāAfree(memoryblock*)̑OmemoryblockNULLłȂ
 *   `FbNĂ̂AMSDNCu[̃QW[t@XQƂɍ폜B
 *
 */


/////////////////////////////////////////////////////////////////////////////////
//
#include "SignatureListener.h"


/////////////////////////////////////////////////////////////////////////////////
//
SignatureListener::SignatureListener()
{
    didSigning = false;
    ::ZeroMemory(&sigData.signingKeyID, sizeof(sigData.signingKeyID));
    sigData.signingKey = kInvalidPGPKeyRef;
    sigData.checked = FALSE;
    sigData.verified = FALSE;
    sigData.keyRevoked = FALSE;
    sigData.keyDisabled = FALSE;
    sigData.keyExpired = FALSE;
    sigData.keyMeetsValidityThreshold = FALSE;
    sigData.keyValidity = kPGPValidity_Unknown;
    sigData.creationTime = kPGPExpirationTime_Never;
    axiomatic = FALSE;
    signingKey = FALSE;
    trustValue = kPGPKeyTrust_Undefined;
}


SignatureListener::~SignatureListener()
{
}


const PGPEventSignatureData* SignatureListener::getData() const
{
    return &sigData;
}


const string& SignatureListener::getName() const
{
    return name;
}


const PGPValidity SignatureListener::getKeyValidity() const
{
    return sigData.keyValidity;
}


bool SignatureListener::isChecked() const
{
    return (sigData.checked == TRUE);
}


bool SignatureListener::isVerified() const
{
    return (sigData.verified == TRUE);
}


bool SignatureListener::isSigned() const
{
    return didSigning;
}


bool SignatureListener::isAxiomatic() const
{
    return (axiomatic == TRUE);
}


bool SignatureListener::isSigningKey() const
{
    return (signingKey == TRUE);
}


PGPInt32 SignatureListener::getTrustValue() const
{
    return trustValue;
}


void SignatureListener::setSignatureEventData(PGPEvent* event)
{
    PGPEventSignatureData* data = reinterpret_cast<PGPEventSignatureData*>(&event->data.signatureData);
    sigData = *data;

    if (data->signingKey == kInvalidPGPKeyRef) {
        char* name_temp = new char[kPGPMaxKeyIDStringSize];
        PGPGetKeyIDString(&data->signingKeyID, kPGPKeyIDString_Abbreviated, name_temp);
        name.assign(name_temp);
        delete [] name_temp;
    }
    else {
        char* name_temp = NULL;
        PGPSize namelen = 0;
        PGPGetPrimaryUserIDNameBuffer(data->signingKey, namelen, name_temp, &namelen);
        name_temp = new char[namelen+1];
        PGPGetPrimaryUserIDNameBuffer(data->signingKey, namelen, name_temp, &namelen);
        name.assign(name_temp);
        delete [] name_temp;

        PGPGetKeyBoolean(data->signingKey, kPGPKeyPropIsAxiomatic, &axiomatic);
	    PGPGetKeyBoolean(data->signingKey, kPGPKeyPropIsSigningKey, &signingKey);

        PGPGetKeyNumber(data->signingKey, kPGPKeyPropTrust, &trustValue);
/*
        char* finger_temp = new char[128];
	    PGPSize fingerSize = 0;
        PGPInt32 algorithm;
        PGPGetKeyPropertyBuffer(data->signingKey, kPGPKeyPropFingerprint, 128, finger_temp, &fingerSize);
		PGPGetKeyNumber(data->signingKey, kPGPKeyPropAlgID, &algorithm);
		ConvertStringFingerprint (algorithm, finger_temp);
        finger.assign(finger_temp);
        delete [] finger_temp;
*/
    }
}

/*
void SignatureListener::ConvertStringFingerprint(UINT algorithm, LPSTR	fingerPrint) 
{
	int i;
	UINT u;
	char szBuf[20];
	char* p;

	switch (algorithm) {
	case kPGPPublicKeyAlgorithm_RSA :
		memcpy (szBuf, fingerPrint, 16);
		p = fingerPrint;
		for (i=0; i<16; i+=2) {
			switch (i) {
			case 0:
				break;
			case 8:
				*p++ = ' ';
			default :
				*p++ = ' ';
				break;
			}
			u = ((unsigned long)szBuf[i] & 0xFF);
			u <<= 8;
			u |= ((unsigned long)szBuf[i+1] & 0xFF);
			wsprintf (p, "%04lX", u);
			p += 4;
		}
		break;

	case kPGPPublicKeyAlgorithm_DSA :
		memcpy (szBuf, fingerPrint, 20);
		p = fingerPrint;
		for (i=0; i<20; i+=2) {
			switch (i) {
			case 0:
				break;
			case 10:
				*p++ = ' ';
			default :
				*p++ = ' ';
				break;
			}
			u = ((unsigned long)szBuf[i] & 0xFF);
			u <<= 8;
			u |= ((unsigned long)szBuf[i+1] & 0xFF);
			wsprintf (p, "%04lX", u);
			p += 4;
		}
		break;

	default :
		lstrcpy (fingerPrint, "");
		break;
	}
}
*/

PGPError SignatureListener::listenEvent(PGPContextRef context, PGPEvent* event)
{
    /* branch on the received event code */
    PGPError err = kPGPError_NoErr;
    switch(event->type)
    {
    case kPGPEvent_SignatureEvent:
        didSigning = true;
        setSignatureEventData(event);
        break;
    default:
        break;
    }

    return err;
}
